/* 
@ITMillApache2LicenseForJavaFiles@
 */

package com.itmill.toolkit.tests;

import java.util.Iterator;
import java.util.Vector;

import com.itmill.toolkit.ui.Button;
import com.itmill.toolkit.ui.CustomComponent;
import com.itmill.toolkit.ui.Label;
import com.itmill.toolkit.ui.OrderedLayout;
import com.itmill.toolkit.ui.Table;
import com.itmill.toolkit.ui.Button.ClickEvent;

/**
 * 
 * This Component contains some simple test to see that component updates its
 * contents propertly.
 * 
 * @author IT Mill Ltd.
 */
public class TestForTablesInitialColumnWidthLogicRendering extends
        CustomComponent {

    private final OrderedLayout main = new OrderedLayout();

    public TestForTablesInitialColumnWidthLogicRendering() {

        setCompositionRoot(main);
        createNewView();
    }

    public void createNewView() {
        main.removeAllComponents();
        main
                .addComponent(new Label(
                        "Below are same tables that all should render somewhat nice. Also when testing, you might want to try resizing window."));

        Table t;

        // t = new Table("Empty table");
        // main.addComponent(t);

        t = getTestTable(5, 0);
        t.setCaption("Table with only headers");
        // main.addComponent(t);

        t = getTestTable(5, 200);
        t.setCaption("Table with  some cols and lot of rows");
        main.addComponent(t);

        t = getTestTable(5, 5);
        t
                .setCaption("Table with  some cols and rows rows, some col widths fixed");

        Iterator it = t.getContainerPropertyIds().iterator();
        it.next();
        it.next();
        t.setColumnWidth(it.next(), 30);
        t.setColumnWidth(it.next(), 30);
        t.setWidth("700px");
        main.addComponent(t);

        t = getTestTable(12, 4);
        t.setCaption("Table with  some rows and lot of columns");
        main.addComponent(t);

        t = getTestTable(3, 40);
        t
                .setCaption("Table with some columns and wide explicit width. (Ought to widen columns to use all space)");
        t.setWidth(1000);
        main.addComponent(t);

        t = getTestTable(12, 4);
        t.setCaption("Table with  some rows and lot of columns, width == 100%");
        t.setWidth(100, Table.UNITS_PERCENTAGE);
        main.addComponent(t);

        t = getTestTable(12, 100);
        t
                .setCaption("Table with  lot of rows and lot of columns, width == 50%");
        t.setWidth(50, Table.UNITS_PERCENTAGE);
        main.addComponent(t);

        t = getTestTable(5, 100);
        t.setCaption("Table with 40 rows");
        // main.addComponent(t);

        t = getTestTable(4, 4);
        t.setCaption("Table with some rows and width = 200px");

        t.setWidth(200);
        main.addComponent(t);

        final Button b = new Button("refresh view", this, "createNewView");
        main.addComponent(b);

    }

    public static Table getTestTable(int cols, int rows) {
        final Table t = new Table();
        t.setColumnCollapsingAllowed(true);
        for (int i = 0; i < cols; i++) {
            t.addContainerProperty(testString[i], String.class, "");
        }
        t.addContainerProperty("button", Button.class, null);
        for (int i = 0; i < rows; i++) {
            final Vector content = new Vector();
            for (int j = 0; j < cols; j++) {
                content.add(rndString());
            }
            content.add(new Button("b", new Button.ClickListener() {

                public void buttonClick(ClickEvent event) {
                    System.out.println("b click");

                }
            }));
            t.addItem(content.toArray(), "" + i);
        }
        return t;
    }

    static String[] testString = new String[] { "Jacob", "Michael", "Joshua",
            "Matthew", "Ethan", "Andrew", "Daniel", "Anthony", "Christopher",
            "Joseph", "William", "Alexander", "Ryan", "David", "Nicholas",
            "Tyler", "James", "John", "Jonathan", "Nathan", "Samuel",
            "Christian", "Noah", "Dylan", "Benjamin", "Logan", "Brandon",
            "Gabriel", "Zachary", "Jose", "Elijah", "Angel", "Kevin", "Jack",
            "Caleb", "Justin", "Austin", "Evan", "Robert", "Thomas", "Luke",
            "Mason", "Aidan", "Jackson", "Isaiah", "Jordan", "Gavin", "Connor",
            "Aiden", "Isaac", "Jason", "Cameron", "Hunter", "Jayden", "Juan",
            "Charles", "Aaron", "Lucas", "Luis", "Owen", "Landon", "Diego",
            "Brian", "Adam", "Adrian", "Kyle", "Eric", "Ian", "Nathaniel",
            "Carlos", "Alex", "Bryan", "Jesus", "Julian", "Sean", "Carter",
            "Hayden", "Jeremiah", "Cole", "Brayden", "Wyatt", "Chase",
            "Steven", "Timothy", "Dominic", "Sebastian", "Xavier", "Jaden",
            "Jesse", "Devin", "Seth", "Antonio", "Richard", "Miguel", "Colin",
            "Cody", "Alejandro", "Caden", "Blake", "Carson" };

    public static String rndString() {
        return testString[(int) (Math.random() * testString.length)];
    }

}
